import java.io.*;
public class expipes {

  public static void main(String args[]) {
     Producer p = new Producer();

     Consumer c = new Consumer(p);
     c.start();
     p.start();
  }
}





///// This class writes into the pipe until it is full, at which
///// point it is blocked until the consumer takes something out.

class Producer extends Thread {
    protected PipedOutputStream po = new PipedOutputStream();
    private DataOutputStream dos = new DataOutputStream(po);

    public void run() {
       // just keep producing numbers 
       for(;;) produce();
    }

    private int sequence=0;
    private final int id() { 
        return sequence++;
    }

    void produce() {
       long t = id();
       System.out.println("produced " + t);
       try {dos.writeLong( t );}
       catch (IOException ie) { System.out.println(ie); }
    }

}

///////
///// This class consumes everything sent over the pipe.
///// The pipe does the synchronization.  When the pipe is full,
///// this threads read from the pipe is blocked.
class Consumer extends Thread {
   private PipedInputStream pip;
   private DataInputStream d;

   // java constructor idiom, save argument.
   Consumer(Producer who) {
      try {
          pip = new PipedInputStream(who.po);
          d = new DataInputStream( pip );
      } catch (IOException ie) {
          System.out.println(ie);
      }
   }

    long get(){
       long i=0;
       try {   i= d.readLong();  // read from pipe.
       } catch (IOException ie) {System.out.println(ie);}
       return i;
    }

   public void run() {
      java.util.Random r = new java.util.Random();
      for(;;) {
          long result = get();
          System.out.println("consumed: "+result);
          // next lines are just to make things asynchronous
          int randomtime = r.nextInt() % 1250;
          try{sleep(randomtime);} catch(Exception e){}
      }
   }
}
