    public class showWaitNotify {
      public static void main(String args[]) {
         Producer p = new Producer();

         Consumer c = new Consumer(p);
         p.start();
         c.start();
      }
    }

//////////////////////////////////

class Producer extends Thread {
    private String [] buffer = new String [8];
    private int pi = 0;  // produce index
    private int gi = 0;  // get index

    public void run() {
       // just keep producing 
       for(;;) produce(); 
    }

    private int sequence=0;
    private final String id() { 
        return "" + sequence++;
    }

    synchronized void produce() {
       // while there isn't room in the buffer
       while ( pi-gi+1 > buffer.length ) {
           try {wait();} catch(Exception e) {}
       }
       int index = pi % buffer.length;
       buffer[index] = id();
       System.out.println("produced["+ index +"] " + buffer[index]);
       pi++;
       notifyAll(); 
    }

    synchronized String consume(){
       // while there's nothing left to take from the buffer
       while (pi==gi) {
           try {wait();} catch(Exception e) {}
       }
       int index = gi++ % buffer.length;
       String result = buffer[index];
       notifyAll();
       return result;
    }
}

/////////////////////////////////////

class Consumer extends Thread {
   Producer whoIamTalkingTo;
   // java idiom for a constructor
   Consumer(Producer who) { whoIamTalkingTo = who; }

   public void run() {
      java.util.Random r = new java.util.Random();
      for(;;) {
          String result = whoIamTalkingTo.consume();
          System.out.println("consumed: "+result);
          // next line is just to make it run a bit slower.
          int randomtime = Math.abs(r.nextInt() % 250);
          try{sleep(randomtime);} catch(Exception e){}
      }
   }
}
