// to use the generic feature, compile with javac -source 1.5 tls.java

class MyThreadLocal extends ThreadLocal <Integer>{
    private static int id = 0;

    // this method overrides a method in ThreadLocal
    protected synchronized Integer initialValue() {
        return id++;  // auto-boxing at work for you.
    }

    // this method overrides a method in ThreadLocal
    public Integer get() {
        return super.get();
    }

}

//////////////////////

class ThreadWithTLS extends Thread {
    private static MyThreadLocal tls = new MyThreadLocal();
    public void run() {
        System.out.println("My thread local value is " + tls.get());
    } 
}

///////////////////////

public class tls {

    public static void main(String args[]) {
       	for(int i=0; i<5; i++) 
            new ThreadWithTLS().start();
    }
}


