import java.io.*; 
import java.nio.*; 
import java.nio.channels.*; 
public class MyMap { 
   public static void main(String args[]) throws Exception { 
      FileOutputStream fos = new FileOutputStream("ints.bin"); 
      FileChannel c = fos.getChannel(); 
      ////////////// write using channel and buffer ////////// 
      ByteBuffer bb = ByteBuffer.allocate(40); 
      IntBuffer ib = bb.asIntBuffer();   // this is a view 
      // fill the buffer 
      for (int i=0; i<10; i++)  ib.put(i); 
      // write the buffer full of ints to the channel and thus file 
      c.write(bb); 
      c.force(true);   // commit to disk 
      c.close(); 

      /////////////////////// read back using mapped I/O ////////// 
      // read back loads of ints into a channel 
      FileInputStream fis = new FileInputStream("ints.bin"); 
      c = fis.getChannel(); 
      MappedByteBuffer mbb = c.map(FileChannel.MapMode.READ_ONLY, 0, 40); 
      // int num = c.read(mbb);   // you don't read a mapped buffer! 
      System.out.println("byte buff capacity: " + mbb.capacity() ); 
      System.out.println("byte buff position: " + mbb.position() ); 
      System.out.println("byte buff    limit: " + mbb.limit() ); 
      for (int i=0; i<10; i++)  { 
          int j = mbb.getInt(); 
          if (j != i) System.out.println("data mismatch: "+i+","+j); 
      } 
      System.out.println("Read the ints back from file ok"); 
   } 
} 
