
import javax.xml.parsers.*; 
import org.xml.sax.*; 
import org.xml.sax.helpers.*; 
import org.w3c.dom.*; 
import java.io.*;

public class DOMEcho { 

    static PrintStream out = System.out;

    public static void main(String[] args) throws Exception { 

      // Step 1: create a DocumentBuilderFactory 
        DocumentBuilderFactory dbf = 
            DocumentBuilderFactory.newInstance(); 
      // We can set various configuration choices on dbf now 
      // (to ignore comments, do validation, etc) 

     // Step 2: create a DocumentBuilder  
        DocumentBuilder db = null; 
        try { 
            db = dbf.newDocumentBuilder(); 
        } catch (ParserConfigurationException pce) { 
            System.err.println(pce); 
            System.exit(1); 
        } 
        // Step 3: parse the input file 
        Document doc = null; 
        try { 
            doc = db.parse(new File(args[0])); 
        } catch (SAXException se) { 
            System.err.println(se.getMessage()); 
            System.exit(1); 
        } catch (IOException ioe) { 
            System.err.println(ioe); 
            System.exit(1); 
        } 

       // Step 4: echo the document 
        echo( doc ); 

       }



    /** 
     * Recursive routine to print out DOM tree nodes 
     */ 
    private static void echo(Node n) { 
        int type = n.getNodeType(); 
        switch (type) { 
        case Node.DOCUMENT_NODE: 
            out.print("DOC:"); 
            break; 
        case Node.DOCUMENT_TYPE_NODE: 
            out.print("DOC_TYPE:"); 
            break; 
        case Node.ELEMENT_NODE: 
            out.print("ELEM:"); 
            break; 
        case Node.TEXT_NODE: 
            out.print("TEXT:"); 
            break; 
        default: 
            out.print("OTHER NODE: " + type); 
            break; 
        } 

        out.print(" nodeName=\"" + n.getNodeName() + "\""); 

        String val = n.getNodeValue(); 
        if (val != null) { 
            if ( !(val.trim().equals(""))) { 
                out.print(" nodeValue \""  
                   + n.getNodeValue() + "\""); 
            } 
        } 
        out.println(); 

 // Print children if any 
        for (Node child = n.getFirstChild(); child != null; 
                 child = child.getNextSibling()) { 
            echo(child); 
          } 
    } 

}


