import java.io.*;     
import org.xml.sax.*; 
import org.xml.sax.helpers.DefaultHandler; 
import javax.xml.parsers.SAXParserFactory; 
import javax.xml.parsers.ParserConfigurationException; 
import javax.xml.parsers.SAXParser;


public class MySAXEcho extends org.xml.sax.helpers.DefaultHandler { 

    public static void main(String argv[]) { 
        // Get a SAX Factory 
        SAXParserFactory factory = SAXParserFactory.newInstance(); 

        // Use an instance of ourselves as the SAX event handler 
        DefaultHandler me = new MySAXEcho(); 

        try { 
            SAXParser sp  = factory.newSAXParser(); 

            // Parse the input 
            sp.parse( new File(argv[0]), me); 

        } catch (Throwable t) { 
            t.printStackTrace(); 
        } 
    } 

    static private PrintStream  o = System.out;
      // get a Parser 
      // register my callbacks, and parse the file 

//=========================================================== 
    // SAX DocumentHandler methods 
    //=========================================================== 

    public void startDocument() 
    throws SAXException 
    { 
        o.println("In startDocument"); 
    } 

    public void startElement(String namespaceURI, 
                             String sName, // simple name (localName) 
                             String qName, // qualified name 
                             Attributes attrs) 
    throws SAXException 
    { 
        o.print( "got elem <"+sName); 
        if (attrs != null) { 
            for (int i = 0; i < attrs.getLength(); i++) { 
                o.println(attrs.getLocalName(i)+"=\""+attrs.getValue(i)+"\""); 
            } 
        } 
        o.println(""); 
    } 

    public void characters (char buf[], int offset, int len) 
            throws SAXException { 
        String s = new String(buf, offset, len); 
        o.print(s); 
    } 

    public void endElement(String namespaceURI, 
                           String sName, // simple name 
                           String qName  // qualified name 
                          ) 
    throws SAXException 
    { 
        o.println("</"+sName+""); 
    } 

}
